// mainfrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "test.h"

#include "mainfrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CPersistentFrame)

BEGIN_MESSAGE_MAP(CMainFrame, CPersistentFrame)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_GAUGE_TEST, OnGaugeTest)
	ON_WM_TIMER()
	ON_UPDATE_COMMAND_UI(ID_GAUGE_TEST, OnUpdateGaugeTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars

// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
	// same order as in the bitmap 'toolbar.bmp'
	ID_FILE_NEW,
	ID_FILE_OPEN,
	ID_FILE_SAVE,
		ID_SEPARATOR,
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
		ID_SEPARATOR,
	ID_FILE_PRINT,
	ID_APP_ABOUT,
};

static UINT BASED_CODE indicators[] =
{
	ID_SEPARATOR,			// status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{    
	m_percent = 0;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
		!m_wndToolBar.SetButtons(buttons,
		  sizeof(buttons)/sizeof(UINT)))
	{
		TRACE("Failed to create toolbar\n");
		return -1;		// fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE("Failed to create status bar\n");
		return -1;		// fail to create
	}   

	UINT nID, nStyle;
	int cxWidth;	
	m_wndStatusBar.GetPaneInfo(0, nID, nStyle, cxWidth);
	nStyle |= SBPS_PERCENT;
	m_wndStatusBar.SetPaneInfo(0, nID, nStyle, cxWidth);

	m_wndStatusBar.GetPaneInfo(2, nID, nStyle, cxWidth);
	nStyle |= SBPS_PERCENT;
	m_wndStatusBar.SetPaneInfo(2, nID, nStyle, cxWidth);

	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnGaugeTest()
{
	SetTimer(1, 500, NULL);	   
	OnTimer(1);
}

void CMainFrame::OnTimer(UINT nIDEvent)
{
	if (nIDEvent == 1)
	{
		m_percent += 10;
		if (m_percent > 100)
		{
			m_wndStatusBar.SetPercent(0);	
			m_wndStatusBar.UpdateWindow();
			KillTimer(1);  
			m_percent = 0;
		} else {
			m_wndStatusBar.SetPercent(m_percent);	
			m_wndStatusBar.UpdateWindow();
		}
	}
}

void CMainFrame::OnUpdateGaugeTest(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(!m_percent);	
}
