// testview.cpp : implementation of the CTestView class
//

#include "stdafx.h"
#include "test.h"   

extern "C" {
#include "itsybits.h"
}

#include "testdoc.h"
#include "testview.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestView

IMPLEMENT_DYNCREATE(CTestView, CView)

BEGIN_MESSAGE_MAP(CTestView, CView)
	//{{AFX_MSG_MAP(CTestView)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestView construction/destruction

CTestView::CTestView()
{
}

CTestView::~CTestView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CTestView drawing

void CTestView::OnDraw(CDC* pDC)
{  
	CString msg = "Left Click (+)\n\n"\
	              "Shift Left DblClk (-)\n\n"\
	              "Right Click swaps" ;

	CRect r;
	GetClientRect( &r ) ;
	r.InflateRect( -3, -3 ) ;

	pDC->DrawText( msg, msg.GetLength(), &r, DT_NOPREFIX | DT_WORDBREAK ) ;
}



/////////////////////////////////////////////////////////////////////////////
// CTestView diagnostics

#ifdef _DEBUG
void CTestView::AssertValid() const
{
	CView::AssertValid();
}

void CTestView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTestDoc* CTestView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTestDoc)));
	return (CTestDoc*) m_pDocument;
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTestView message handlers

void CTestView::OnLButtonDown(UINT nFlags, CPoint point)
{
	HWND hWnd = GetParent()->GetSafeHwnd();
	
    if (nFlags & MK_SHIFT)
        ibSetCaptionSize( hWnd, ibGetCaptionSize( hWnd ) - 1 ) ;
    else
        ibSetCaptionSize( hWnd, ibGetCaptionSize( hWnd ) + 1 ) ;
}

void CTestView::OnRButtonDown(UINT nFlags, CPoint point)
{                                 
	HWND hWnd = GetParent()->GetSafeHwnd();
	
	DWORD dw = GetWindowLong( hWnd, GWL_STYLE ) ;
	RECT rc ;
	                       
	if (dw & IBS_HORZCAPTION)
	{
	    dw &= ~IBS_HORZCAPTION ;
	    dw |= IBS_VERTCAPTION ;
	}
	else
	{
	    dw &= ~IBS_VERTCAPTION ;
	    dw |= IBS_HORZCAPTION ;
	}            
	SetWindowLong( hWnd, GWL_STYLE, (LONG)dw) ;
	
	::GetWindowRect( hWnd, &rc ) ;
	        
	// Once we change the window style, we need a WM_NCCALCRECT
	// to be generated.
	//
	// SWP_FRAMECHANGED is not documented in the 3.1 SDK docs,
	// but *is* in WINDOWS.H.
	//
	::SetWindowPos( hWnd, NULL, 0, 0, 0, 0, SWP_FRAMECHANGED | 
	                    SWP_NOSIZE | SWP_NOMOVE | 
	                    SWP_NOACTIVATE | SWP_NOZORDER) ;
}

